<?php
// +----------------------------------------------------------------------
// | likeadmin快速开发前后端分离管理后台（PHP版）
// +----------------------------------------------------------------------
// | 欢迎阅读学习系统程序代码，建议反馈是我们前进的动力
// | 开源版本可自由商用，可去除界面版权logo
// | gitee下载：https://gitee.com/likeshop_gitee/likeadmin
// | github下载：https://github.com/likeshop-github/likeadmin
// | 访问官网：https://www.likeadmin.cn
// | likeadmin团队 版权所有 拥有最终解释权
// +----------------------------------------------------------------------
// | author: likeadminTeam
// +----------------------------------------------------------------------

namespace app\adminapi\lists\device;


use app\adminapi\lists\BaseAdminDataLists;
use app\common\model\device\MonitorAlarm;
use app\common\lists\ListsSearchInterface;


/**
 * MonitorAlarm列表
 * Class MonitorAlarmLists
 * @package app\adminapi\listsdevice
 */
class MonitorAlarmLists extends BaseAdminDataLists implements ListsSearchInterface
{


    /**
     * @notes 设置搜索条件
     * @return \string[][]
     * @author likeadmin
     * @date 2023/11/24 16:34
     */
    public function setSearch(): array
    {
        $allowSearch = ['start_time', 'end_time'];
        if (!empty($this->params['device_id'])) {
            $allowSearch[] = 'device_id';
        }
        if (!empty($this->params['type'])) {
            $allowSearch[] = 'type';
        }
        return array_intersect(array_keys($this->params), $allowSearch);
    }

    public function userSearch(): array
    {
        $userWhere['user_id'] = -1;
        // 超级管理员数据
        if ($this->adminInfo['root'] && !$this->adminInfo['user_id']) {
            unset($userWhere['user_id']);
        }
        // 普通用户数据
        if (!$this->adminInfo['root'] && $this->adminInfo['user_id']) {
            $userWhere['user_id'] = $this->adminInfo['user_id'];
        }
        return $userWhere;
    }

    /**
     * @notes 获取列表
     * @return array
     * @throws \think\db\exception\DataNotFoundException
     * @throws \think\db\exception\DbException
     * @throws \think\db\exception\ModelNotFoundException
     * @author likeadmin
     * @date 2023/11/24 16:34
     */
    public function lists(): array
    {
        return MonitorAlarm::withSearch($this->setSearch(), $this->params)->where($this->userSearch())->with('device')
            ->field(['id', 'device_id', 'type', 'content', 'value', 'solution', 'create_time'])
            ->limit($this->limitOffset, $this->limitLength)
            ->order(['id' => 'desc'])
            ->select()
            ->toArray();
    }


    /**
     * @notes 获取数量
     * @return int
     * @author likeadmin
     * @date 2023/11/24 16:34
     */
    public function count(): int
    {
        return MonitorAlarm::withSearch($this->setSearch(), $this->params)->where($this->userSearch())->count();
    }

}